"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var store = new Map();
var getReadmeId = function getReadmeId(kind, storyName) {
  return kind + "." + storyName;
};

var getReadme = exports.getReadme = function getReadme(kind, storyName) {
  var id = getReadmeId(kind, storyName);

  if (!store.has(id)) {
    return [];
  }

  return store.get(id);
};

var setReadme = exports.setReadme = function setReadme(kind, storyName) {
  var readme = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  var id = getReadmeId(kind, storyName);
  store.set(id, Array.isArray(readme) ? readme : [readme]);
};