'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _storybookAddons = require('@kadira/storybook-addons');

var _storybookAddons2 = _interopRequireDefault(_storybookAddons);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var withReadme = function withReadme(readme) {
  var storyFn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;


  var emitAddReadme = function emitAddReadme(_ref) {
    var kind = _ref.kind,
        story = _ref.story;

    _storybookAddons2.default.getChannel().emit(_constants.ADD_README_EVENT, {
      kind: kind,
      storyName: story,
      readme: readme
    });
  };

  // if there is no storyFn - expect hat withReadme is usead as decorator
  // .addDecorator(withReadme(readme))
  // .addStory('Button', () => <Button />)
  if (storyFn === null) {
    return function (storyFn, _ref2) {
      var kind = _ref2.kind,
          story = _ref2.story;

      emitAddReadme({ kind: kind, story: story });
      return storyFn();
    };
  } else {
    return function (_ref3) {
      var kind = _ref3.kind,
          story = _ref3.story;

      emitAddReadme({ kind: kind, story: story });
      return storyFn();
    };
  }
};

exports.default = withReadme;